<?php
/**
 * InlineObject5
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineObject5 Class Doc Comment
 *
 * @category Class
 * @description This object represents a remote support
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineObject5 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_object_5';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'remoteMaintenanceId' => 'string',
        'typeId' => 'int',
        'userId' => 'string',
        'userName' => 'string',
        'employeeId' => 'int',
        'deviceId' => 'string',
        'deviceName' => 'string',
        'companyId' => 'int',
        'linkTypeId' => 'int',
        'linkId' => 'int',
        'startTime' => 'int',
        'endTime' => 'int',
        'comment' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'remoteMaintenanceId' => null,
        'typeId' => null,
        'userId' => null,
        'userName' => null,
        'employeeId' => null,
        'deviceId' => null,
        'deviceName' => null,
        'companyId' => null,
        'linkTypeId' => null,
        'linkId' => null,
        'startTime' => 'timestamp',
        'endTime' => 'timestamp',
        'comment' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'remoteMaintenanceId' => 'remoteMaintenanceId',
        'typeId' => 'typeId',
        'userId' => 'userId',
        'userName' => 'userName',
        'employeeId' => 'employeeId',
        'deviceId' => 'deviceId',
        'deviceName' => 'deviceName',
        'companyId' => 'companyId',
        'linkTypeId' => 'linkTypeId',
        'linkId' => 'linkId',
        'startTime' => 'startTime',
        'endTime' => 'endTime',
        'comment' => 'comment'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'remoteMaintenanceId' => 'setRemoteMaintenanceId',
        'typeId' => 'setTypeId',
        'userId' => 'setUserId',
        'userName' => 'setUserName',
        'employeeId' => 'setEmployeeId',
        'deviceId' => 'setDeviceId',
        'deviceName' => 'setDeviceName',
        'companyId' => 'setCompanyId',
        'linkTypeId' => 'setLinkTypeId',
        'linkId' => 'setLinkId',
        'startTime' => 'setStartTime',
        'endTime' => 'setEndTime',
        'comment' => 'setComment'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'remoteMaintenanceId' => 'getRemoteMaintenanceId',
        'typeId' => 'getTypeId',
        'userId' => 'getUserId',
        'userName' => 'getUserName',
        'employeeId' => 'getEmployeeId',
        'deviceId' => 'getDeviceId',
        'deviceName' => 'getDeviceName',
        'companyId' => 'getCompanyId',
        'linkTypeId' => 'getLinkTypeId',
        'linkId' => 'getLinkId',
        'startTime' => 'getStartTime',
        'endTime' => 'getEndTime',
        'comment' => 'getComment'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['remoteMaintenanceId'] = $data['remoteMaintenanceId'] ?? null;
        $this->container['typeId'] = $data['typeId'] ?? null;
        $this->container['userId'] = $data['userId'] ?? null;
        $this->container['userName'] = $data['userName'] ?? null;
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['deviceId'] = $data['deviceId'] ?? null;
        $this->container['deviceName'] = $data['deviceName'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['linkTypeId'] = $data['linkTypeId'] ?? null;
        $this->container['linkId'] = $data['linkId'] ?? null;
        $this->container['startTime'] = $data['startTime'] ?? null;
        $this->container['endTime'] = $data['endTime'] ?? null;
        $this->container['comment'] = $data['comment'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets remoteMaintenanceId
     *
     * @return string|null
     */
    public function getRemoteMaintenanceId()
    {
        return $this->container['remoteMaintenanceId'];
    }

    /**
     * Sets remoteMaintenanceId
     *
     * @param string|null $remoteMaintenanceId \"Identifier\" used by the remote systems to identify this remote support
     *
     * @return self
     */
    public function setRemoteMaintenanceId($remoteMaintenanceId)
    {
        $this->container['remoteMaintenanceId'] = $remoteMaintenanceId;

        return $this;
    }

    /**
     * Gets typeId
     *
     * @return int|null
     */
    public function getTypeId()
    {
        return $this->container['typeId'];
    }

    /**
     * Sets typeId
     *
     * @param int|null $typeId \"Id\" of the external remote support system, which is defined in the TANSS administration (\"Externe Fernwartungs-Anbindungen verwalten\"). This field can't be set, as the Api token was created for a specific \"type\" and this value is fix.
     *
     * @return self
     */
    public function setTypeId($typeId)
    {
        $this->container['typeId'] = $typeId;

        return $this;
    }

    /**
     * Gets userId
     *
     * @return string|null
     */
    public function getUserId()
    {
        return $this->container['userId'];
    }

    /**
     * Sets userId
     *
     * @param string|null $userId \"Identifier string\" of the technician who has done this remote support. This can be used to \"translate\" the identifier of the technician to a TANSS employee id
     *
     * @return self
     */
    public function setUserId($userId)
    {
        $this->container['userId'] = $userId;

        return $this;
    }

    /**
     * Gets userName
     *
     * @return string|null
     */
    public function getUserName()
    {
        return $this->container['userName'];
    }

    /**
     * Sets userName
     *
     * @param string|null $userName name of the technician who has done this remote support, this is mainly used for displaying issues
     *
     * @return self
     */
    public function setUserName($userName)
    {
        $this->container['userName'] = $userName;

        return $this;
    }

    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId Id of the technician who has done this remote support (TANSS employee id). This can be omitted if the id is not known or the \"userId\" can be \"translated\"
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets deviceId
     *
     * @return string|null
     */
    public function getDeviceId()
    {
        return $this->container['deviceId'];
    }

    /**
     * Sets deviceId
     *
     * @param string|null $deviceId \"Identifier string\" or unique name of the device the remote support was executed for. This can be used via a \"translation table\" to get the company and/or assignment.
     *
     * @return self
     */
    public function setDeviceId($deviceId)
    {
        $this->container['deviceId'] = $deviceId;

        return $this;
    }

    /**
     * Gets deviceName
     *
     * @return string|null
     */
    public function getDeviceName()
    {
        return $this->container['deviceName'];
    }

    /**
     * Sets deviceName
     *
     * @param string|null $deviceName Simply the name of the device the remote support was executed for. This is mainly used for displying issues.
     *
     * @return self
     */
    public function setDeviceName($deviceName)
    {
        $this->container['deviceName'] = $deviceName;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId id of the company for this remote support
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets linkTypeId
     *
     * @return int|null
     */
    public function getLinkTypeId()
    {
        return $this->container['linkTypeId'];
    }

    /**
     * Sets linkTypeId
     *
     * @param int|null $linkTypeId LinkTypeId of the assignment (if known)
     *
     * @return self
     */
    public function setLinkTypeId($linkTypeId)
    {
        $this->container['linkTypeId'] = $linkTypeId;

        return $this;
    }

    /**
     * Gets linkId
     *
     * @return int|null
     */
    public function getLinkId()
    {
        return $this->container['linkId'];
    }

    /**
     * Sets linkId
     *
     * @param int|null $linkId LinkId of the assignment (if known)
     *
     * @return self
     */
    public function setLinkId($linkId)
    {
        $this->container['linkId'] = $linkId;

        return $this;
    }

    /**
     * Gets startTime
     *
     * @return int|null
     */
    public function getStartTime()
    {
        return $this->container['startTime'];
    }

    /**
     * Sets startTime
     *
     * @param int|null $startTime Unix timestamp of the begin for this remote support
     *
     * @return self
     */
    public function setStartTime($startTime)
    {
        $this->container['startTime'] = $startTime;

        return $this;
    }

    /**
     * Gets endTime
     *
     * @return int|null
     */
    public function getEndTime()
    {
        return $this->container['endTime'];
    }

    /**
     * Sets endTime
     *
     * @param int|null $endTime Unix timestamp of the end for this remote support
     *
     * @return self
     */
    public function setEndTime($endTime)
    {
        $this->container['endTime'] = $endTime;

        return $this;
    }

    /**
     * Gets comment
     *
     * @return string|null
     */
    public function getComment()
    {
        return $this->container['comment'];
    }

    /**
     * Sets comment
     *
     * @param string|null $comment (optional) comment of the remote support
     *
     * @return self
     */
    public function setComment($comment)
    {
        $this->container['comment'] = $comment;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


